<?php

namespace Drupal\user_provisioning\Helpers;

use Drupal\Core\Form\FormBase;
use Drupal\Core\Form\FormStateInterface;
use Drupal\Core\Render\Markup;

/**
 * Helper class for fetching all the data related to User Specific Provisioning tab
 */
class moProviderSpecificProvisioning
{
    private $url_path;

    /**
     * Constructor for the Provider Specific Provisioning tab
     */
    public function __construct()
    {
        global $base_url;
        $this->url_path = $base_url . '/' . \Drupal::service('extension.list.module')->getPath('user_provisioning'). '/images';
    }

    /**
     * @return array of providers for provider specific provisioning
     */
    public function providerList(){
        return array(
            Markup::create('<a><img class="mo_user_provisioning_under_disabled mo_user_provisioning_img_logo" alt="Azure AD B2C" src="' . $this->url_path . '/azure.png"><br><strong>Azure AD B2C</strong>  </a>'),
            Markup::create('<a><img class="mo_user_provisioning_under_disabled mo_user_provisioning_img_logo" alt="AWS Cognito" src="' . $this->url_path . '/cognito.png"><br><strong>AWS Cognito</strong>  </a>'),
            Markup::create('<a><img class="mo_user_provisioning_under_disabled mo_user_provisioning_img_logo" alt="miniOrange" src="' . $this->url_path . '/miniorange.png"><br><strong>miniOrange</strong>  </a>'),
            Markup::create('<a><img class="mo_user_provisioning_under_disabled mo_user_provisioning_img_logo" alt="Salesforce" src="' . $this->url_path . '/salesforce.png"><br><strong>Salesforce</strong>  </a>'),
        );

    }
}
