<?php

namespace Drupal\user_provisioning\SCIMParser;

use Drupal\Core\Entity\EntityInterface;
use Drupal\user_provisioning\Helpers\moUserProvisioningLogger;
use Drupal\user_provisioning\moUserProvisioningConstants;

class moUserProvisioningUserParser implements moUserProvisioningResourceParserInterface
{
    private moUserProvisioningLogger $mo_logger;

    public function __construct()
    {
        $this->mo_logger = new moUserProvisioningLogger();
    }

    /**
     * @inheritDoc
     */
    public function search($resource_id): string
    {
        $this->mo_logger->addLog("Creating search request parameter.", __LINE__, __FUNCTION__, __FILE__);
        return 'Users?filter=userName eq "' . $resource_id . '"';
    }

    /**
     * @inheritDoc
     */
    public function get($resource_id)
    {
        // TODO: Implement get() method.
    }

    /**
     * @inheritDoc
     */
    public function post(EntityInterface $entity)
    {
        //the bare minimum attributes
        $post_request_body = array(
            'schemas' => moUserProvisioningConstants::USER_SCHEMAS,
            'externalId' => $entity->getEmail(),
            'userName' => $entity->getEmail(),
            'email' => $entity->getEmail(),
            'displayName' => $entity->getEmail(),
        );

        $this->mo_logger->addFormattedLog($post_request_body, __LINE__, __FUNCTION__, __FILE__, 'User create request body: ');

        //additional attributes
        //consider the mapping made before picking up the additional attributes

        return $post_request_body;
    }

    /**
     * @inheritDoc
     */
    public function put(array $resource)
    {
        // TODO: Implement put() method.
    }

    /**
     * @inheritDoc
     */
    public function patch(array $resource)
    {
        // TODO: Implement patch() method.
    }

    /**
     * @inheritDoc
     */
    public function delete(array $resource)
    {
        // TODO: Implement delete() method.
    }
}