<?php

namespace Drupal\user_provisioning;

use Drupal\Core\Entity\EntityInterface;
use Drupal\user_provisioning\EntityHandler\moUserProvisioningEntityHandlerInterface;
use Drupal\user_provisioning\EntityHandler\moUserProvisioningUserHandler;
use Drupal\user_provisioning\Helpers\moUserProvisioningLogger;
use http\Exception\InvalidArgumentException;

class moUserProvisioningEntityFactory
{
    /**
     * @param EntityInterface $entity
     * @return moUserProvisioningEntityHandlerInterface
     */
    public static function getEntityHandler(EntityInterface $entity): moUserProvisioningEntityHandlerInterface
    {
        if ($entity->getEntityTypeId() == 'user') {
            $moLogger = new moUserProvisioningLogger();
            $moLogger->addLog("Creating and returning moUserProvisioningUserHandler object.", __LINE__, __FUNCTION__, __FILE__);
            return new moUserProvisioningUserHandler($entity);
        }

        else {
            throw new InvalidArgumentException();
        }
    }
}